set_property IOSTANDARD LVCMOS33 [get_ports oTraceData]
set_property PACKAGE_PIN L19     [get_ports {oTraceData[0]}]
set_property PACKAGE_PIN J21     [get_ports {oTraceData[1]}]
set_property PACKAGE_PIN H21     [get_ports {oTraceData[2]}]
set_property PACKAGE_PIN H18     [get_ports {oTraceData[3]}]
set_property PACKAGE_PIN H19     [get_ports {oTraceData[4]}]
set_property PACKAGE_PIN J17     [get_ports {oTraceData[5]}]
set_property PACKAGE_PIN H17     [get_ports {oTraceData[6]}]
set_property PACKAGE_PIN L18     [get_ports {oTraceData[7]}]
set_property PACKAGE_PIN G18     [get_ports {oTraceData[8]}]
set_property PACKAGE_PIN G19     [get_ports {oTraceData[9]}]
set_property PACKAGE_PIN F17     [get_ports {oTraceData[10]}]
set_property PACKAGE_PIN F18     [get_ports {oTraceData[11]}]
set_property PACKAGE_PIN E19     [get_ports {oTraceData[12]}]
set_property PACKAGE_PIN D19     [get_ports {oTraceData[13]}]
set_property PACKAGE_PIN E17     [get_ports {oTraceData[14]}]
set_property PACKAGE_PIN E18     [get_ports {oTraceData[15]}]

set_property IOSTANDARD LVCMOS33 [get_ports oTraceClk]
set_property PACKAGE_PIN K17     [get_ports oTraceClk]

set_property IOSTANDARD LVCMOS33 [get_ports oLEDs]
set_property PACKAGE_PIN AG14    [get_ports {oLEDs[0]}]
set_property PACKAGE_PIN AF13    [get_ports {oLEDs[1]}]
set_property PACKAGE_PIN AE13    [get_ports {oLEDs[2]}]
set_property PACKAGE_PIN AJ14    [get_ports {oLEDs[3]}]
set_property PACKAGE_PIN AJ15    [get_ports {oLEDs[4]}]
set_property PACKAGE_PIN AH13    [get_ports {oLEDs[5]}]
set_property PACKAGE_PIN AH14    [get_ports {oLEDs[6]}]
set_property PACKAGE_PIN AL12    [get_ports {oLEDs[7]}]

set_property IOSTANDARD LVCMOS33 [get_ports iDIPs]
set_property PACKAGE_PIN AN14    [get_ports {iDIPs[0]}]
set_property PACKAGE_PIN AP14    [get_ports {iDIPs[1]}]
set_property PACKAGE_PIN AM14    [get_ports {iDIPs[2]}]
set_property PACKAGE_PIN AN13    [get_ports {iDIPs[3]}]
set_property PACKAGE_PIN AN12    [get_ports {iDIPs[4]}]
set_property PACKAGE_PIN AP12    [get_ports {iDIPs[5]}]
set_property PACKAGE_PIN AL13    [get_ports {iDIPs[6]}]
set_property PACKAGE_PIN AK13    [get_ports {iDIPs[7]}]

set_property IOSTANDARD LVDS_25  [get_ports iClk125P]
set_property IOSTANDARD LVDS_25  [get_ports iClk125N]
set_property PACKAGE_PIN G21     [get_ports iClk125P]
create_clock -period 8.000 -name clk125 -waveform {0.000 4.000} [get_ports iClk125P]

set_property IOSTANDARD LVDS_25  [get_ports iClk74_25P]
set_property IOSTANDARD LVDS_25  [get_ports iClk74_25N]
set_property PACKAGE_PIN AK15    [get_ports iClk74_25P]
create_clock -period 13.468 -name clk74_25 -waveform {0.000 6.734} [get_ports iClk74_25P]

# built-in programmable reference clock -- Quad 229 MGTREFCLK0
# Note: in the default setup, Linux changes the frequency of this clock while booting!
#set_property PACKAGE_PIN L27     [get_ports iAuroraRefP]
#create_clock -period 6.011783 -name clkauroraref -waveform {0.000 3.005892} [get_ports iAuroraRefP]

# HSSTP reference clock on HPC0 GBTCLK0 -- Quad 228 MGTREFCLK0
# Note: Due to the odd routing on the ZCU102 board, this clock cannot be used together with the Hpc0 Transceivers!
#set_property PACKAGE_PIN G8      [get_ports iAuroraHpc0RefAnalyzerP]
#create_clock -period 2.5 -name clkauroraref -waveform {0.000 1.25} [get_ports iAuroraHpc0RefAnalyzerP]

# fixed 156.2 MHz reference clock on HPC0 GBTCLK1 -- Quad 229 MGTREFCLK0
#set_property PACKAGE_PIN L8       [get_ports iAuroraHpc0RefFixedP]
#create_clock -period 6.011783 -name clkauroraref -waveform {0.000 3.005892} [get_ports iAuroraHpc0RefFixedP]

# HSSTP reference clock on HPC1 GBTCLK0 -- Quad 130 MGTREFCLK0
set_property PACKAGE_PIN G27     [get_ports iAuroraHpc1RefAnalyzerP]
create_clock -period 2.5 -name clkauroraref -waveform {0.000 1.25} [get_ports iAuroraHpc1RefAnalyzerP]

# fixed 156.2 MHz reference clock on HPC1 GBTCLK1 -- Quad 130 MGTREFCLK1
set_property PACKAGE_PIN E27     [get_ports iAuroraHpc1RefFixedP]
create_clock -period 6.011783 -name clkauroraref -waveform {0.000 3.005892} [get_ports iAuroraHpc1RefFixedP]

# SMA connector
#set_property PACKAGE_PIN M29     [get_ports {oAuroraSmaTxP[0]}]

# HPC0 connector -- Quad 229 and 230 (left side): X1Y10 X1Y9 X1Y11 X1Y8 X1Y7 X1Y5
#set_property PACKAGE_PIN G4      [get_ports {oAuroraHpc0TxP[0]}]
#set_property PACKAGE_PIN H6      [get_ports {oAuroraHpc0TxP[1]}]
#set_property PACKAGE_PIN F6      [get_ports {oAuroraHpc0TxP[2]}]
#set_property PACKAGE_PIN K6      [get_ports {oAuroraHpc0TxP[3]}]
#set_property PACKAGE_PIN M6      [get_ports {oAuroraHpc0TxP[4]}]
#set_property PACKAGE_PIN P6      [get_ports {oAuroraHpc0TxP[5]}]

# HPC1 connector -- Quad 129 and 130 (right side): X0Y12 X0Y13 X0Y14 X0Y15 X0Y8 X0Y9
set_property PACKAGE_PIN F29     [get_ports {oAuroraHpc1TxP[0]}]
set_property PACKAGE_PIN D29     [get_ports {oAuroraHpc1TxP[1]}]
set_property PACKAGE_PIN B29     [get_ports {oAuroraHpc1TxP[2]}]
set_property PACKAGE_PIN A31     [get_ports {oAuroraHpc1TxP[3]}]
set_property PACKAGE_PIN K29     [get_ports {oAuroraHpc1TxP[4]}]
set_property PACKAGE_PIN J31     [get_ports {oAuroraHpc1TxP[5]}]

# HPC0 connector LEDs
set_property IOSTANDARD LVCMOS18 [get_ports oFMCLEDs]
set_property PACKAGE_PIN V11     [get_ports {oHpc0LEDs[0]}]
set_property PACKAGE_PIN V12     [get_ports {oHpc0LEDs[1]}]
set_property PACKAGE_PIN T11     [get_ports {oHpc0LEDs[2]}]
set_property PACKAGE_PIN U11     [get_ports {oHpc0LEDs[3]}]

# HPC1 connector LEDs are not connected to the FPGA!

set_property BITSTREAM.GENERAL.COMPRESS TRUE [current_design]
